#include "app_nrf24l01.h"

/**************************************************************************************************
* 汾V1.00
* ڣ2024-10-01
* ܣNRF24L01ͨ
* £ʼ汾
* ߣרҵ
**************************************************************************************************/

const u8 TX_ADDRESS[TX_ADR_WIDTH]={0x34,0x43,0x10,0x10,0x01}; //͵ַ
const u8 RX_ADDRESS[RX_ADR_WIDTH]={0x34,0x43,0x10,0x10,0x01}; //͵ַ

/**************************************************************************************************
* ܣNRF24L01ʼ
* 
* 
**************************************************************************************************/
void NRF24L01_Init(void)
{
	NRF24L01_CE  = 0;
	NRF24L01_CSN = 1;	
	SCK = 0; 													//SPIʱ

	NRF24L01_IRQ = 1; 
	
	NRF24L01_Check();
	
	NRF24L01_RX_Mode();
}

/**************************************************
Function: SPI_RW();

  Description:
  Writes one byte to nRF24L01, and return the byte read
  from nRF24L01 during write, according to SPI protocol
/**************************************************/
uchar SPI1_ReadWriteByte(uchar byte)
{
	uchar bit_ctr;
   	for(bit_ctr=0;bit_ctr<8;bit_ctr++) // output 8-bit
   	{
		MOSI = (byte & 0x80);         // output 'byte', MSB to MOSI
		byte = (byte << 1);           // shift next bit into MSB..
		SCK = 1;                      // Set SCK high..
		byte |= MISO;       		  // capture current MISO bit
		SCK = 0;            		  // ..then set SCK low again
   	}
    return(byte);           		  // return read byte
}

//SPIдĴ
//reg:ָĴַ
//value:дֵ
u8 NRF24L01_Write_Reg(u8 reg,u8 value)
{
	u8 status;	
  NRF24L01_CSN=0;                 //ʹSPI
  status =SPI1_ReadWriteByte(reg);//ͼĴ 
  SPI1_ReadWriteByte(value);      //дĴֵ
  NRF24L01_CSN=1;                 //ֹSPI	   
  return(status);       			//״ֵ̬
}
//ȡSPIĴֵ
//reg:ҪļĴ
u8 NRF24L01_Read_Reg(u8 reg)
{
	u8 reg_val;	    
  NRF24L01_CSN = 0;          //ʹSPI		
  SPI1_ReadWriteByte(reg);   //ͼĴ
  reg_val=SPI1_ReadWriteByte(0XFF);//ȡĴ
  NRF24L01_CSN = 1;          //ֹSPI		    
  return(reg_val);           //״ֵ̬
}	
//ָλöָȵ
//reg:Ĵ(λ)
//*pBuf:ָ
//len:ݳ
//ֵ,˴ζ״̬Ĵֵ 
u8 NRF24L01_Read_Buf(u8 reg,u8 *pBuf,u8 len)
{
  u8 status,u8_ctr;	       
  NRF24L01_CSN = 0;           //ʹSPI
  status=SPI1_ReadWriteByte(reg);//ͼĴֵ(λ),ȡ״ֵ̬   	   
  for(u8_ctr=0;u8_ctr<len;u8_ctr++)pBuf[u8_ctr]=SPI1_ReadWriteByte(0XFF);//
  NRF24L01_CSN=1;       //رSPI
  return status;        //ض״ֵ̬
}
//ָλдָȵ
//reg:Ĵ(λ)
//*pBuf:ָ
//len:ݳ
//ֵ,˴ζ״̬Ĵֵ
u8 NRF24L01_Write_Buf(u8 reg, u8 *pBuf, u8 len)
{
  u8 status,u8_ctr;	    
 	NRF24L01_CSN = 0;          //ʹSPI
  status = SPI1_ReadWriteByte(reg);//ͼĴֵ(λ),ȡ״ֵ̬
  for(u8_ctr=0; u8_ctr<len; u8_ctr++)SPI1_ReadWriteByte(*pBuf++); //д	 
  NRF24L01_CSN = 1;       //رSPI
  return status;          //ض״ֵ̬
}				   
//NRF24L01һ
//txbuf:׵ַ
//ֵ:״
u8 NRF24L01_TxPacket(u8 *txbuf)
{
	u8 sta;
 
	NRF24L01_CE=0;
	NRF24L01_Write_Buf(WR_TX_PLOAD,txbuf,TX_PLOAD_WIDTH);//дݵTX BUF  32ֽ
 	NRF24L01_CE=1;//	   
	while(NRF24L01_IRQ!=0);//ȴ
	sta=NRF24L01_Read_Reg(STATUS);  //ȡ״̬Ĵֵ	   
	NRF24L01_Write_Reg(NRF_WRITE_REG+STATUS,sta); //TX_DSMAX_RTжϱ־
	if(sta&MAX_TX)//ﵽط
	{
		NRF24L01_Write_Reg(FLUSH_TX,0xff);//TX FIFOĴ 
		return MAX_TX; 
	}
	if(sta&TX_OK)//
	{
		return TX_OK;
	}
	return 0xff;//ԭʧ
}
//NRF24L01һ
//txbuf:׵ַ
//ֵ:0ɣ
u8 NRF24L01_RxPacket(u8 *rxbuf)
{
	u8 sta;		    							   

	sta=NRF24L01_Read_Reg(STATUS);  //ȡ״̬Ĵֵ    	 
	NRF24L01_Write_Reg(NRF_WRITE_REG+STATUS,sta); //TX_DSMAX_RTжϱ־
	if(sta&RX_OK)//յ
	{
		NRF24L01_Read_Buf(RD_RX_PLOAD,rxbuf,RX_PLOAD_WIDTH);//ȡ
		NRF24L01_Write_Reg(FLUSH_RX,0xff);//RX FIFOĴ 
		return 0; 
	}	   
	return 1;//ûյκ
}					    
//úʼNRF24L01RXģʽ
//RXַ,дRXݿ,ѡRFƵ,ʺLNA HCURR
//CEߺ,RXģʽ,Խ		   
void NRF24L01_RX_Mode(void)
{
  NRF24L01_CE=0;	  
  NRF24L01_Write_Buf(NRF_WRITE_REG+RX_ADDR_P0,(u8*)RX_ADDRESS,RX_ADR_WIDTH);//дRXڵַ
	  
  NRF24L01_Write_Reg(NRF_WRITE_REG+EN_AA,0x01);    //ʹͨ0ԶӦ    
  NRF24L01_Write_Reg(NRF_WRITE_REG+EN_RXADDR,0x01);//ʹͨ0Ľյַ  	 
  NRF24L01_Write_Reg(NRF_WRITE_REG+RF_CH,40);	     //RFͨƵ		  
  NRF24L01_Write_Reg(NRF_WRITE_REG+RX_PW_P0,RX_PLOAD_WIDTH);//ѡͨ0Чݿ 	    
  NRF24L01_Write_Reg(NRF_WRITE_REG+RF_SETUP,0x0f);//TX,0db,2Mbps,濪   
  NRF24L01_Write_Reg(NRF_WRITE_REG+CONFIG, 0x0f);//ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ 
  NRF24L01_CE = 1; //CEΪ,ģʽ 
}						 
//úʼNRF24L01TXģʽ
//TXַ,дTXݿ,RXԶӦĵַ,TX,ѡRFƵ,ʺLNA HCURR
//PWR_UP,CRCʹ
//CEߺ,RXģʽ,Խ		   
//CEΪߴ10us,.	 
void NRF24L01_TX_Mode(void)
{														 
	NRF24L01_CE=0;	    
  NRF24L01_Write_Buf(NRF_WRITE_REG+TX_ADDR,(u8*)TX_ADDRESS,TX_ADR_WIDTH);//дTXڵַ 
  NRF24L01_Write_Buf(NRF_WRITE_REG+RX_ADDR_P0,(u8*)RX_ADDRESS,RX_ADR_WIDTH); //TXڵַ,ҪΪʹACK	  

  NRF24L01_Write_Reg(NRF_WRITE_REG+EN_AA,0x01);     //ʹͨ0ԶӦ    
  NRF24L01_Write_Reg(NRF_WRITE_REG+EN_RXADDR,0x01); //ʹͨ0Ľյַ  
  NRF24L01_Write_Reg(NRF_WRITE_REG+SETUP_RETR,0x1a);//Զطʱ:500us + 86us;Զط:10
  NRF24L01_Write_Reg(NRF_WRITE_REG+RF_CH,40);       //RFͨΪ40
  NRF24L01_Write_Reg(NRF_WRITE_REG+RF_SETUP,0x0f);  //TX,0db,2Mbps,濪   
  NRF24L01_Write_Reg(NRF_WRITE_REG+CONFIG,0x0e);    //ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ,ж
	NRF24L01_CE=1;//CEΪ,10us
}

//24L01Ƿ
//ֵ:0ɹ;1ʧ	
u8 NRF24L01_Check(void)
{
	u8 buf[5]={0XA5,0XA5,0XA5,0XA5,0XA5};
	u8 i;
 	 
	NRF24L01_Write_Buf(NRF_WRITE_REG+TX_ADDR,buf,5);//д5ֽڵĵַ.	
	NRF24L01_Read_Buf(TX_ADDR,buf,5); //дĵַ  
	for(i=0;i<5;i++)if(buf[i]!=0XA5)break;	 							   
	if(i!=5)return 1;//24L01	
	return 0;		 //⵽24L01
}
