#ifndef __APP_NRF24L01_H
#define __APP_NRF24L01_H

/**************************************************************************************************
* 汾V1.00
* ڣ2024-10-01
* ܣNRF24L01ͨͷļ
* £ʼ汾
* ߣרҵ
**************************************************************************************************/

#include "app_public.h"
#include "params.h"

//nRF24L01+ PIN DEFINITION
#define	MOSI      		P15             // Master Out, Slave In pin (output)
#define	MISO      		P16             // Master In, Slave Out pin (input)
#define	SCK       		P17             // Serial Clock pin, (output)
#define	NRF24L01_CSN    P14             // Slave Select pin, (output to CSN)
#define	NRF24L01_CE     P52             // Chip Enable pin signal (output)
#define	NRF24L01_IRQ    P53             // Interrupt signal, from nRF24L01 (input)

//24L01ͽݿȶ
#define TX_ADR_WIDTH    5   	//5ֽڵĵַ
#define RX_ADR_WIDTH    5   	//5ֽڵĵַ
#define TX_PLOAD_WIDTH  32  	//32ֽڵûݿ
#define RX_PLOAD_WIDTH  32  	//32ֽڵûݿ

//NRF24L01Ĵ
#define NRF_READ_REG    0x00  //üĴ,5λΪĴַ
#define NRF_WRITE_REG   0x20  //дüĴ,5λΪĴַ
#define RD_RX_PLOAD     0x61  //RXЧ,1~32ֽ
#define WR_TX_PLOAD     0xA0  //дTXЧ,1~32ֽ
#define FLUSH_TX        0xE1  //TX FIFOĴ.ģʽ
#define FLUSH_RX        0xE2  //RX FIFOĴ.ģʽ
#define REUSE_TX_PL     0xE3  //ʹһ,CEΪ,ݰϷ.
#define _NOP             0xFF  //ղ,״̬Ĵ	 
//SPI(NRF24L01)Ĵַ
#define CONFIG          0x00  //üĴַ;bit0:1ģʽ,0ģʽ;bit1:ѡ;bit2:CRCģʽ;bit3:CRCʹ;
                              //bit4:жMAX_RT(ﵽطж)ʹ;bit5:жTX_DSʹ;bit6:жRX_DRʹ
#define EN_AA           0x01  //ʹԶӦ  bit0~5,Ӧͨ0~5
#define EN_RXADDR       0x02  //յַ,bit0~5,Ӧͨ0~5
#define SETUP_AW        0x03  //õַ(ͨ):bit1,0:00,3ֽ;01,4ֽ;02,5ֽ;
#define SETUP_RETR      0x04  //Զط;bit3:0,Զط;bit7:4,Զطʱ 250*x+86us
#define RF_CH           0x05  //RFͨ,bit6:0,ͨƵ;
#define RF_SETUP        0x06  //RFĴ;bit3:(0:1Mbps,1:2Mbps);bit2:1,书;bit0:Ŵ
#define STATUS          0x07  //״̬Ĵ;bit0:TX FIFO־;bit3:1,ͨ(:6);bit4,ﵽط
                              //bit5:ݷж;bit6:ж;
#define MAX_TX  		0x10  //ﵽʹж
#define TX_OK   		0x20  //TXж
#define RX_OK   		0x40  //յж

#define OBSERVE_TX      0x08  //ͼĴ,bit7:4,ݰʧ;bit3:0,ط
#define CD              0x09  //زĴ,bit0,ز;
#define RX_ADDR_P0      0x0A  //ͨ0յַ,󳤶5ֽ,ֽǰ
#define RX_ADDR_P1      0x0B  //ͨ1յַ,󳤶5ֽ,ֽǰ
#define RX_ADDR_P2      0x0C  //ͨ2յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P3      0x0D  //ͨ3յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P4      0x0E  //ͨ4յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P5      0x0F  //ͨ5յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define TX_ADDR         0x10  //͵ַ(ֽǰ),ShockBurstTMģʽ,RX_ADDR_P0˵ַ
#define RX_PW_P0        0x11  //ͨ0Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P1        0x12  //ͨ1Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P2        0x13  //ͨ2Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P3        0x14  //ͨ3Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P4        0x15  //ͨ4Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P5        0x16  //ͨ5Чݿ(1~32ֽ),Ϊ0Ƿ
#define NRF_FIFO_STATUS 0x17  //FIFO״̬Ĵ;bit0,RX FIFOĴձ־;bit1,RX FIFO־;bit2,3,
                              //bit4,TX FIFOձ־;bit5,TX FIFO־;bit6,1,ѭһݰ.0,ѭ;

//
void NRF24L01_Init(void);
u8 NRF24L01_TxPacket(u8 *txbuf);
u8 NRF24L01_RxPacket(u8 *rxbuf);
void NRF24L01_RX_Mode(void);
void NRF24L01_TX_Mode(void);
u8 NRF24L01_Check(void);

#endif
